<?php

/**
 * inf_general_func actions.
 *
 * @package    nomina
 * @subpackage inf_general_func
 * @author     Manuel Enrique Paredes Lopez
 * @email       mparedes@sofhouse.net
 * @fecha       19/11/19
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_general_funcActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }
        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //estado
            if (isset($request['estado']) && $request['estado'] == 'true') {
                $whereEstado = " AND tab0.estado = 1 ";
            } else if (isset($request['estado']) && $request['estado'] == '0') {
                $whereEstado = " AND tab0.estado = 0 ";
            }else if(isset($request['estado'])&&$request['estado']=='false') {
                $whereEstado = " AND tab0.estado IN (0,1)";
            }
            else {
                $whereEstado = ' ';
            }
            //CENTRO DE OPERACION
            if (isset($request['id_cen_op'])) {
                $whereCentroOperacion = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCentroOperacion = ' ';
            }

            //AREA
            
            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_ea = " . $request['id_area'];
            } else {
                $whereArea = ' ';
            }
            
            
            
            
            
            

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            /**
             * Consulta de debitos pendientes de pago
             * Solo debitos con titulos de canon y con tipo de tasa registrada
             */
            $consulta_sql = <<<EOD
select
dat.id_tipo_doc,
dat.tipo_documento,
dat.num_doc,
dat.primer_apellido,
dat.segundo_apellido,
dat.primer_nombre,
dat.segundo_nombre,
dat.nombre_apellido,
nom.fecha_nombra,
dat.sexo,
case when dat.sexo = 1 then 'FEMENINO' else 'MASCULINO' end as genero,
nom.fecha_ingreso,
nom.fecha_ingreso + nvl(tab7.num_dias,0) as fecha_antiguedad,
nom.estado,
nom.fecha_retiro,
case 
when tipest.id_tipo_estudio is not null then tipest.descripcion
when titbas.id_titulo_basica is not null then titbas.descripcion
else null end as nivel_academico,
dp.componente as cargo,
dp.centro as centro_func,
dp.area as area_func,
dp.id_ea,
dp.id_cen_op,
tab7.num_dias as num_dias
from no_datos_funcionario_v dat
left join no_nombramiento_v nom
on nom.num_doc = dat.num_doc
and nom.id_tipo_doc = dat.id_tipo_doc
    
left join (
    SELECT
    aut.*,
    ROW_NUMBER() OVER (
        partition by aut.num_doc
        ORDER BY aut.num_doc, aut.id_anhos desc, aut.id_meses desc
    ) AS rnn
    from no_estado_func_v aut
)tab5
on dat.id_tipo_doc = tab5.id_tipo_doc and dat.num_doc = tab5.num_doc
and tab5.rnn = 1

left join NO_DP_V dp
on dp.id_dp = tab5.id_dp

left join (
    SELECT
    aut.*,
    ROW_NUMBER() OVER (
        partition by aut.num_doc
        ORDER BY aut.num_doc, aut.fecha_fin desc
    ) AS rn
    from formacion_superior aut
)tab6
on dat.id_tipo_doc = tab6.id_tipo_doc and dat.num_doc = tab6.num_doc
and tab6.rn = 1

left join tipo_estudio tipest
on tipest.id_tipo_estudio = tab6.id_tipo_estudio

left join tipo_titulo_basica titbas
on titbas.id_titulo_basica = dat.id_titulo_basica  
    
left join (
    select
    nov.id_tipo_doc,
    nov.num_doc,
    sum(nvl(nov.num_dias,0)) as num_dias
    from no_novedad_kardex nov
    left join no_tip_nov_ka tip
    on tip.id_tip_nov_ka = nov.id_tip_nov_ka
    where
    tip.afecta_antigu = 1
    and nov.estado = 1
    group by
    nov.id_tipo_doc,
    nov.num_doc
)tab7
on dat.id_tipo_doc = tab7.id_tipo_doc and dat.num_doc = tab7.num_doc  
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.*
from(
    
    $consulta_sql

)tab0
                    
where
1 = 1     
$whereFuncionarioNumDoc  
$whereFuncionarioTipoDoc  
$whereEstado    
$whereCentroOperacion
$whereArea 
                    
)
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
tab0.*
from(
    
    $consulta_sql

)tab0
                    
where
1 = 1     
$whereFuncionarioNumDoc  
$whereFuncionarioTipoDoc 
$whereEstado    
$whereCentroOperacion
$whereArea                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_general_func] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
